<?php

class ActionQuantik{
    //attributs
    protected PlateauQuantik $plateau;
    //constructeurs
    public function __construct(PlateauQuantik $plateau){
        $this->plateau = $plateau;
    }

    public function getPlateau():PlateauQuantik {
        return $this->plateau;
    }

    public function isRowWin(int $numRow):bool {
        $arrPiece = $this->plateau->getRow($numRow);
        return self::isComboWin($arrPiece);
    }

    public function isColWin(int $numCol):bool {
        $arrPiece = $this->plateau->getCol($numCol);
        return self::isComboWin($arrPiece);
    }

    public function isCornerWin(int $dir): bool {
        $arrPiece = $this->plateau->getCorner($dir);
        return self::isComboWin($arrPiece);
    }

    public function isValidePose(int $rowNum, int $colNum, PieceQuantik $piece): bool{
        $colonne = $this->plateau->getCol($colNum);
        $ligne = $this->plateau->getRow($rowNum);
        return self::isPieceValide($colonne, $piece) && self::isPieceValide($ligne, $piece);
    }

    public function posePiece(int $rowNum, int $colNum, PieceQuantik $piece): void{
        if(self::isValidePose($rowNum, $colNum, $piece)){
            $this->plateau->setPiece($rowNum, $colNum, $piece);
            echo "La pièce ". $piece . " a bien été posée en (" . $rowNum . ";" . $colNum .")";
        } else {
            echo "Il est impossible de poser la pièce en (" . $rowNum . ";" . $colNum .")";
            echo "Il existe déjà la pièce " . $this->plateau->getPiece($rowNum, $colNum) . " à cet emplacement";
        }
    }
    private static function isComboWin(ArrayPieceQuantik $pieces): bool{
        $formeInitiale = $pieces->getPieceQuantik(0)->getForme();
        for($i = 1; $i < $pieces->count(); $i++){
            if($formeInitiale === $pieces->getPieceQuantik($i)->getForme() || $formeInitiale == 0){
                return false;
            }
        }
        return true;
    }
    private static function isPieceValide(ArrayPieceQuantik $pieces, PieceQuantik $p): bool {
        $nbPiecePosees = 0;
        $formeP = $p->getForme();
        $couleurP = $p->getCouleur();
        $count = $pieces->count();
        for($i = 0; $i < $count; $i++){
            $pieceInitiale = $pieces->getPieceQuantik($i);
            $formePieceInitiale = $pieceInitiale->getForme();
            if($formePieceInitiale !== 0){
                $nbPiecePosees++;
            }
            if($formePieceInitiale === $formeP && $pieceInitiale->getCouleur() === $couleurP){
                return false;
            }
        }
        return $nbPiecePosees < 4;
    }
}